/* bbRepMask.c was originally generated by the autoSql program, which also 
 * generated bbRepMask.h and bbRepMask.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "jksql.h"
#include "bbRepMask.h"

void bbRepMaskStaticLoad(char **row, struct bbRepMask *ret)
/* Load a row from bbRepMask table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->seqId = sqlUnsigned(row[0]);
ret->seqStart = sqlUnsigned(row[1]);
ret->seqEnd = sqlUnsigned(row[2]);
ret->bin = sqlUnsigned(row[3]);
ret->name = row[4];
ret->score = sqlUnsigned(row[5]);
strcpy(ret->strand, row[6]);
ret->repFamily = row[7];
ret->repStart = sqlSigned(row[8]);
ret->repEnd = sqlSigned(row[9]);
ret->repLeft = sqlSigned(row[10]);
ret->milliDiv = sqlUnsigned(row[11]);
ret->milliDel = sqlUnsigned(row[12]);
ret->milliIns = sqlUnsigned(row[13]);
}

struct bbRepMask *bbRepMaskLoad(char **row)
/* Load a bbRepMask from row fetched with select * from bbRepMask
 * from database.  Dispose of this with bbRepMaskFree(). */
{
struct bbRepMask *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->seqId = sqlUnsigned(row[0]);
ret->seqStart = sqlUnsigned(row[1]);
ret->seqEnd = sqlUnsigned(row[2]);
ret->bin = sqlUnsigned(row[3]);
ret->name = cloneString(row[4]);
ret->score = sqlUnsigned(row[5]);
strcpy(ret->strand, row[6]);
ret->repFamily = cloneString(row[7]);
ret->repStart = sqlSigned(row[8]);
ret->repEnd = sqlSigned(row[9]);
ret->repLeft = sqlSigned(row[10]);
ret->milliDiv = sqlUnsigned(row[11]);
ret->milliDel = sqlUnsigned(row[12]);
ret->milliIns = sqlUnsigned(row[13]);
return ret;
}

struct bbRepMask *bbRepMaskLoadAll(char *fileName) 
/* Load all bbRepMask from a tab-separated file.
 * Dispose of this with bbRepMaskFreeList(). */
{
struct bbRepMask *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[14];

while (lineFileRow(lf, row))
    {
    el = bbRepMaskLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct bbRepMask *bbRepMaskCommaIn(char **pS, struct bbRepMask *ret)
/* Create a bbRepMask out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new bbRepMask */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->seqId = sqlUnsignedComma(&s);
ret->seqStart = sqlUnsignedComma(&s);
ret->seqEnd = sqlUnsignedComma(&s);
ret->bin = sqlUnsignedComma(&s);
ret->name = sqlStringComma(&s);
ret->score = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->strand, sizeof(ret->strand));
ret->repFamily = sqlStringComma(&s);
ret->repStart = sqlSignedComma(&s);
ret->repEnd = sqlSignedComma(&s);
ret->repLeft = sqlSignedComma(&s);
ret->milliDiv = sqlUnsignedComma(&s);
ret->milliDel = sqlUnsignedComma(&s);
ret->milliIns = sqlUnsignedComma(&s);
*pS = s;
return ret;
}

void bbRepMaskFree(struct bbRepMask **pEl)
/* Free a single dynamically allocated bbRepMask such as created
 * with bbRepMaskLoad(). */
{
struct bbRepMask *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->repFamily);
freez(pEl);
}

void bbRepMaskFreeList(struct bbRepMask **pList)
/* Free a list of dynamically allocated bbRepMask's */
{
struct bbRepMask *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    bbRepMaskFree(&el);
    }
*pList = NULL;
}

void bbRepMaskOutput(struct bbRepMask *el, FILE *f, char sep, char lastSep) 
/* Print out bbRepMask.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
fprintf(f, "%u", el->seqId);
fputc(sep,f);
fprintf(f, "%u", el->seqStart);
fputc(sep,f);
fprintf(f, "%u", el->seqEnd);
fputc(sep,f);
fprintf(f, "%u", el->bin);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->score);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->repFamily);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%d", el->repStart);
fputc(sep,f);
fprintf(f, "%d", el->repEnd);
fputc(sep,f);
fprintf(f, "%d", el->repLeft);
fputc(sep,f);
fprintf(f, "%u", el->milliDiv);
fputc(sep,f);
fprintf(f, "%u", el->milliDel);
fputc(sep,f);
fprintf(f, "%u", el->milliIns);
fputc(lastSep,f);
}

